Index: code/branches/questsystem2/src/orxonox/objects/quest/AddQuest.cc
===================================================================
--- code/branches/questsystem2/src/orxonox/objects/quest/AddQuest.cc	(revision 2208)
+++ code/branches/questsystem2/src/orxonox/objects/quest/AddQuest.cc	(revision 2209)
@@ -92,4 +92,6 @@
         }
 
+        COUT(3) << "AddQuest on player: " << player << " ." << std::endl;
+
         try
         {
@@ -106,5 +108,5 @@
         }
 
-	COUT(3) << "Quest {" << this->getQuestId() << "} successfully added to player." << std::endl;
+        COUT(3) << "Quest {" << this->getQuestId() << "} successfully added to player." << std::endl;
         return true;
     }
Index: code/branches/questsystem2/src/orxonox/objects/quest/CompleteQuest.cc
===================================================================
--- code/branches/questsystem2/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2208)
+++ code/branches/questsystem2/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2209)
@@ -89,7 +89,11 @@
         }
 
+        COUT(3) << "CompleteQuest on player: " << player << " ." << std::endl;
+
+        Quest* quest;
+
         try
         {
-            Quest* quest = QuestManager::findQuest(this->getQuestId());
+            quest = QuestManager::findQuest(this->getQuestId());
             if(!quest->complete(player))
             {
@@ -103,4 +107,5 @@
         }
 
+        COUT(3) << "Quest {" << quest->getId() << "} successfully completed by player: " << player << " ." << std::endl;
         return true;
     }
Index: code/branches/questsystem2/src/orxonox/objects/quest/QuestEffectBeacon.cc
===================================================================
--- code/branches/questsystem2/src/orxonox/objects/quest/QuestEffectBeacon.cc	(revision 2208)
+++ code/branches/questsystem2/src/orxonox/objects/quest/QuestEffectBeacon.cc	(revision 2209)
@@ -71,11 +71,18 @@
     }
     
-    bool QuestEffectBeacon::execute(bool b, ControllableEntity* entity)
-    {
-        if(!b || !(this->isActive()))
+    bool QuestEffectBeacon::execute(bool b, PlayerTrigger* trigger)
+    {
+        if(!b)
+        {
+            COUT(2) << "b is false." << std::endl;
+        }
+        if(!(this->isActive()))
         {
             COUT(3) << "The QuestEffectBeacon is inactive." << std::endl;
             return false;
         }
+
+        ControllableEntity* entity = trigger->getTriggeringPlayer();
+
         if(entity == NULL)
         {
@@ -91,5 +98,7 @@
             return false;
         }
-        
+
+        COUT(3) << "QuestEffectBeacon executed on player: " << player << " ." << std::endl;        
+
         bool check = QuestEffect::invokeEffects(player, this->effects_);
         if(check)
Index: code/branches/questsystem2/src/orxonox/objects/quest/QuestEffectBeacon.h
===================================================================
--- code/branches/questsystem2/src/orxonox/objects/quest/QuestEffectBeacon.h	(revision 2208)
+++ code/branches/questsystem2/src/orxonox/objects/quest/QuestEffectBeacon.h	(revision 2209)
@@ -65,5 +65,5 @@
 	    virtual void processEvent(Event& event);
 	    
-	    bool execute(bool b, ControllableEntity* player); //!< Executes the QuestEffects of the QuestEffectBeacon.
+	    bool execute(bool b, PlayerTrigger* trigger); //!< Executes the QuestEffects of the QuestEffectBeacon.
 	    
 	    bool isActive(void); //!< Test whether the QuestEffectBeacon is active.
Index: code/branches/questsystem2/src/orxonox/objects/worldentities/triggers/DistanceTrigger.cc
===================================================================
--- code/branches/questsystem2/src/orxonox/objects/worldentities/triggers/DistanceTrigger.cc	(revision 2208)
+++ code/branches/questsystem2/src/orxonox/objects/worldentities/triggers/DistanceTrigger.cc	(revision 2209)
@@ -141,5 +141,4 @@
     if (Trigger::isTriggered(mode))
     {
-        COUT(3) << "Triggers" << std::endl;
       return checkDistance();
     }