Index: /code/branches/buildsystem/bin/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem/bin/CMakeLists.txt	(revision 2242)
+++ /code/branches/buildsystem/bin/CMakeLists.txt	(revision 2243)
@@ -1,16 +1,34 @@
 SET(CONFIG_FILES
-    def_keybindings.ini
-    disco.txt
-    irc.tcl
-    ogre.cfg-init
-    orxonox.bat
-    Plugins.cfg
-    plugins.cfg-init
-    remote.tcl
-    run-script
-    telnet_server.tcl
+  def_keybindings.ini
+  disco.txt
+  irc.tcl
+  remote.tcl
+  telnet_server.tcl
 )
 
+IF(IS_TARDIS)
+  SET(CONFIG_FILES ${CONFIG_FILES}
+    linux/run-script
+	tardis/plugins.cfg
+  )
+
+ELSEIF(UNIX)
+  SET(CONFIG_FILES ${CONFIG_FILES}
+    linux/run-script
+	linux/plugins.cfg
+  )
+ENDIF(IS_TARDIS)
+
+IF(MINGW)
+  SET(CONFIG_FILES ${CONFIG_FILES}
+    "mingw/plugins.cfg"
+    "mingw/orxonox.bat"
+  )
+ENDIF(MINGW)
+
 FOREACH(_FILE ${CONFIG_FILES})
-    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${_FILE} ${EXECUTABLE_OUTPUT_PATH}/${_FILE} COPYONLY)
+  GET_FILENAME_COMPONENT(_filename ${_FILE} NAME)
+  IF (NOT EXISTS ${EXECUTABLE_OUTPUT_PATH}/${_filename})
+    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${_FILE} ${EXECUTABLE_OUTPUT_PATH}/${_filename} COPYONLY)
+  ENDIF (NOT EXISTS ${EXECUTABLE_OUTPUT_PATH}/${_filename})
 ENDFOREACH(_FILE)
Index: de/branches/buildsystem/bin/Plugins.cfg
===================================================================
--- /code/branches/buildsystem/bin/Plugins.cfg	(revision 2242)
+++ 	(revision )
@@ -1,13 +1,0 @@
-# Defines plugins to load
-
-# Define plugin folder
-PluginFolder=..\..\libs\ogre\Samples\Common\bin\Release
-
-# Define plugins
-Plugin=RenderSystem_Direct3D9
-Plugin=RenderSystem_GL
-Plugin=Plugin_ParticleFX
-Plugin=Plugin_BSPSceneManager
-Plugin=Plugin_OctreeSceneManager
-#Plugin=Plugin_CgProgramManager
-
Index: /code/branches/buildsystem/bin/linux/plugins.cfg
===================================================================
--- /code/branches/buildsystem/bin/linux/plugins.cfg	(revision 2243)
+++ /code/branches/buildsystem/bin/linux/plugins.cfg	(revision 2243)
@@ -0,0 +1,14 @@
+# Defines plugins to load
+
+# Define plugin folder
+PluginFolder=/usr/lib/OGRE
+
+# Define plugins
+#Plugin=RenderSystem_Direct3D9
+Plugin=RenderSystem_GL
+Plugin=Plugin_ParticleFX
+Plugin=Plugin_CgProgramManager
+#Plugin=Plugin_BSPSceneManager
+#Plugin=Plugin_OctreeSceneManager
+
+
Index: /code/branches/buildsystem/bin/linux/run-script
===================================================================
--- /code/branches/buildsystem/bin/linux/run-script	(revision 2243)
+++ /code/branches/buildsystem/bin/linux/run-script	(revision 2243)
@@ -0,0 +1,11 @@
+#!/bin/sh
+
+if [ ! -f orxonox ]; then
+	echo "orxonox does not exist"
+	echo "did you compile it?"
+
+	exit 1
+fi
+
+trap "xset r && echo 'resetting autorepeat'" HUP INT TERM QUIT ABRT KILL ALRM
+./orxonox $@
Index: /code/branches/buildsystem/bin/mingw/orxonox.bat
===================================================================
--- /code/branches/buildsystem/bin/mingw/orxonox.bat	(revision 2243)
+++ /code/branches/buildsystem/bin/mingw/orxonox.bat	(revision 2243)
@@ -0,0 +1,4 @@
+title Orxonox
+path ..\..\libs;%path%
+orxonox.exe
+pause
Index: /code/branches/buildsystem/bin/mingw/plugins.cfg
===================================================================
--- /code/branches/buildsystem/bin/mingw/plugins.cfg	(revision 2243)
+++ /code/branches/buildsystem/bin/mingw/plugins.cfg	(revision 2243)
@@ -0,0 +1,13 @@
+# Defines plugins to load
+
+# Define plugin folder
+PluginFolder=..\..\libs\ogre\Samples\Common\bin\Release\
+
+# Define plugins
+Plugin=RenderSystem_Direct3D9
+Plugin=RenderSystem_GL
+Plugin=Plugin_ParticleFX
+Plugin=Plugin_CgProgramManager
+#Plugin=Plugin_BSPSceneManager
+#Plugin=Plugin_OctreeSceneManager
+
Index: de/branches/buildsystem/bin/ogre.cfg-init
===================================================================
--- /code/branches/buildsystem/bin/ogre.cfg-init	(revision 2242)
+++ 	(revision )
@@ -1,7 +1,0 @@
-Render System=OpenGL Rendering Subsystem
-
-[OpenGL Rendering Subsystem]
-FSAA=0
-Full Screen=No
-RTT Preferred Mode=FBO
-Video Mode=1024 x 768
Index: de/branches/buildsystem/bin/orxonox.bat
===================================================================
--- /code/branches/buildsystem/bin/orxonox.bat	(revision 2242)
+++ 	(revision )
@@ -1,4 +1,0 @@
-title Orxonox
-path lib;..\..\libs;%path%
-orxonox.exe
-pause
Index: de/branches/buildsystem/bin/plugins.cfg-init
===================================================================
--- /code/branches/buildsystem/bin/plugins.cfg-init	(revision 2242)
+++ 	(revision )
@@ -1,14 +1,0 @@
-# Defines plugins to load
-
-# Define plugin folder
-PluginFolder=/usr/lib/OGRE
-
-# Define plugins
-#Plugin=RenderSystem_Direct3D9
-Plugin=RenderSystem_GL
-Plugin=Plugin_ParticleFX
-Plugin=Plugin_BSPSceneManager
-Plugin=Plugin_OctreeSceneManager
-#Plugin=Plugin_CgProgramManager
-
-
Index: de/branches/buildsystem/bin/run-script
===================================================================
--- /code/branches/buildsystem/bin/run-script	(revision 2242)
+++ 	(revision )
@@ -1,26 +1,0 @@
-#!/bin/sh
-
-if [ ! -f orxonox ]; then
-	echo "orxonox does not exist"
-	echo "did you compile it?"
-
-	exit 1
-fi
-
-if [ ! -f orge.cfg ]; then
-	cp ogre.cfg-init ogre.cfg
-fi
-
-# check if plugins.cfg exists, and of not create it
-# and modify 
-if [ ! -f plugins.cfg ]; then
-	if uname -n | grep -q "tardis"; then
-		sed -e 's:PluginFolder=/usr/lib/OGRE:PluginFolder=/usr/pack/ogre-1.4.5-sd/i686-debian-linux3.1/lib/OGRE/:' \
-		-e 's:#Plugin=Plugin_CgProgramManager:Plugin=Plugin_CgProgramManager:' plugins.cfg-init > plugins.cfg
-	else
-                cp plugins.cfg-init plugins.cfg
-	fi
-fi
-
-trap "xset r && echo 'resetting autorepeat'" HUP INT TERM QUIT ABRT KILL ALRM
-./orxonox $@
Index: /code/branches/buildsystem/bin/tardis/plugins.cfg
===================================================================
--- /code/branches/buildsystem/bin/tardis/plugins.cfg	(revision 2243)
+++ /code/branches/buildsystem/bin/tardis/plugins.cfg	(revision 2243)
@@ -0,0 +1,14 @@
+# Defines plugins to load
+
+# Define plugin folder
+PluginFolder=/usr/pack/ogre-1.4.5-sd/i686-debian-linux3.1/lib/OGRE/
+
+# Define plugins
+#Plugin=RenderSystem_Direct3D9
+Plugin=RenderSystem_GL
+Plugin=Plugin_ParticleFX
+Plugin=Plugin_CgProgramManager
+#Plugin=Plugin_BSPSceneManager
+#Plugin=Plugin_OctreeSceneManager
+
+
Index: /code/branches/buildsystem/cmake/UseTolua.cmake
===================================================================
--- /code/branches/buildsystem/cmake/UseTolua.cmake	(revision 2242)
+++ /code/branches/buildsystem/cmake/UseTolua.cmake	(revision 2243)
@@ -43,5 +43,6 @@
                                   -s "${TOLUA_PARSER_SOURCE}"
                                      "${_tolua_pkgfile}"
-    DEPENDS "${_tolua_executable_name}" ${_tolua_inputfiles} ${TOLUA_PARSER_DEPENDENCIES}
+    DEPENDS "${_tolua_executable_name}" ${TOLUA_PARSER_DEPENDENCIES}
+    IMPLICIT_DEPENDS CXX ${_tolua_inputfiles}
     WORKING_DIRECTORY "${LIBRARY_OUTPUT_PATH}"
   )